//****************************************************************************
//	aisa22s.pas
//
//	aISA-P22
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/19
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa22s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa22w;

const
	szTitle = 'Sample';
	szName = 'aISA-P22';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer, dwDrvVer: DWord;	// DLLCDrivero[W
	bResult:	Boolean;					// 
	wLogSlot: Word;							// foCXi[
	InValue:	Byte;							// ̓f[^
	ri:				TAISA22RESOURCE;	// \[X
begin
//---------------------------------------------------------------------------
	// aisa22.dll ̎gp錾
	if Aisa22wDllOpen() = False then
	begin
		ErrorMessage(AISA22_SLOT_AUTO);
		Exit;			// aisa22.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-P22 DLL,Driver̃o[Wԍ擾
	if Aisa22wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA22_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Drv Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P22̎gp錾
	wLogSlot := AISA22_SLOT_AUTO;				// gp̃foCXT܂B
	bResult := Aisa22wCreate(wLogSlot);	// ꍇA̎̃foCXi[܂B

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA22_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-P22 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);


//---------------------------------------------------------------------------
	// \[X擾
	if Aisa22wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
						 'NumPorts: %2d'#10 +
						 'IO Address: %04xH -%04xH'#10,
											[szName, ri.dwIOPortLength[1],
											ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// Port 0 f[^ǂݍ
	InValue := Byte($00);

	if Aisa22wInPort(wLogSlot, AISA22_PORT_0, InValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Port 0 f[^'#10 +
					 'Port 0 In Data: %02xH',
					 [InValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-P22̎gpJ
	if Aisa22wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-P22 Closed');

	// aisa22.dll ̎gpJ
	if Aisa22wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa22.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa22wGetLastError(wLogSlot);

	case dwRes of
		AISA22_ERR_SYSTEM:
			strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);

		AISA22_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-P22 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
