#ifndef _Aisap22_H_
#define _Aisap22_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AISA22_MAX_SLOTS 	16
#define	AISA22_SLOT_AUTO	((WORD) ~0U)
#define	AISA22_PORT_0		0
#define	AISA22_PORT_1		1
#define	AISA22_PORT_2		2
#define	AISA22_PORT_3		3

// G[R[h
#define AISA22_SUCCESS				0	// ُȂ
#define AISA22_ERR_SYSTEM			1	// GetLastError sĂ
#define AISA22_ERR_NO_DEVICE		2	// gp\ȃfoCXȂ
#define AISA22_ERR_IN_USE			3	// w肳ꂽXbg͎gp
#define AISA22_ERR_INVALID_SLOT		4	// Ș_Xbgԍ
#define AISA22_ERR_RESOURCE			5	// \[XG[
#define AISA22_ERR_INVALID_PORT		6	// ȃ|[gԍ
#define AISA22_ERR_INVALID_ARGUMENT	7	// Ȉ

#define AISA22_MAX_MEM		9
#define AISA22_MAX_IO		20
#define AISA22_MAX_IRQ		7
#define AISA22_MAX_DMA		7

//======================================================================
// \[X\
//======================================================================
typedef struct {
	DWORD	dwNumMemWindows;                   // EChE	gp
	DWORD	dwMemBase		[AISA22_MAX_MEM];  // MWx[XAhX		gp
	DWORD	dwMemLength		[AISA22_MAX_MEM];  // MW					gp
	DWORD	dwMemAttrib		[AISA22_MAX_MEM];  // MW				gp
	DWORD	dwNumIOPorts;                      // I/O|[g
	DWORD	dwIOPortBase	[AISA22_MAX_IO];   // I/O|[gx[XAhX
	DWORD	dwIOPortLength	[AISA22_MAX_IO];   // I/O|[g
	DWORD	dwNumIRQs;                         // IRQ					gp
	DWORD	dwIRQRegisters	[AISA22_MAX_IRQ];  // IRQXg				gp
	DWORD	dwIRQAttrib		[AISA22_MAX_IRQ];  // IRQXg			gp
	DWORD	dwNumDMAs;                         // DMA`l			gp
	DWORD	dwDMALst		[AISA22_MAX_DMA];  // DMA`lXg		gp
	DWORD	dwDMAAttrib		[AISA22_MAX_DMA];  // DMA`lXg	gp
	DWORD	dwReserved1		[3];               // \					gp
} AISA22RESOURCE;

typedef		AISA22RESOURCE *PAISA22R;
typedef		AISA22RESOURCE FAR *LPAISA22R;

//-- ȉAPI --
//======================================================================
// VxD  DLL ̃o[W擾
//======================================================================
BOOL WINAPI Aisa22GetVersion(
	PDWORD		pdwDllVer,		// VxD Version
	PDWORD		pdwVxDVer );	// DLL Version
	
//======================================================================
// foCXgp錾
//======================================================================
BOOL WINAPI Aisa22Create(
	PWORD pwLogSlot );			// Xbgԍ( 0`15 or SLOT_AUTO )
	
//======================================================================
// foCXJ
//======================================================================
BOOL WINAPI Aisa22Close(
	WORD wLogSlot );			// Xbgԍ( 0`15 )
	
//======================================================================
// \[X擾
//======================================================================
BOOL WINAPI Aisa22GetResource(
	WORD	wLogSlot,			// Slot
	AISA22RESOURCE *pRes );		// \[X\̂̃|C^
	
//======================================================================
// C|[g
//======================================================================
BOOL WINAPI Aisa22InPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 3 )
	PBYTE	pbValue );			// l
	
//======================================================================
// Ōw肳ꂽXbgŔsꂽG[R[ho
//======================================================================
DWORD WINAPI Aisa22GetLastError(
	WORD	wLogSlot );			// Slot

#ifdef __cplusplus
}
#endif
#endif
