/*****************************************************************************
 *	aisa22w.c
 *
 *	aISA-P22
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa22w.h"	// aISA-P22

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Aisa22wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa22GetVersion;
static FARPROC pAisa22Create;
static FARPROC pAisa22Close;
static FARPROC pAisa22GetResource;
static FARPROC pAisa22InPort;
static FARPROC pAisa22GetLastError;

BOOL Aisa22wDllOpen ( void )
/*****************************************************************************
 * @\  aisa22.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA22_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa22wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa22wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa22wDllClose ( void )
/*****************************************************************************
 * @\  aisa22.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa22wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  aISA-P22DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE		   --- 
 *		 FALSE		   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa22GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Aisa22wCreate ( PWORD pwLogSlot )
/*****************************************************************************
 * @\  aISA-P22̔Cӂ̃foCX̎gp錾
 * 	 pwLogSlot	--- gpfoCXi[AhX
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa22Create)(pwLogSlot);
}

BOOL Aisa22wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P22̔Cӂ̃foCX̎gpJ
 * 	 wLogSlot  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa22Close)(wLogSlot);
}

BOOL Aisa22wGetResource ( WORD wLogSlot, PAISA22R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSlot --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa22GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa22wInPort ( WORD wLogSlot, DWORD dwPort, PBYTE pbInValue )
/*****************************************************************************
 * @\  Cӂ̃|[gf[^
 * 	 wLogSlot  --- ͂foCX
 *		 dwPort	   --- ͂|[g
 *		 pbInValue --- ̓f[^i[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa22InPort)(wLogSlot, dwPort, pbInValue);
}

DWORD Aisa22wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P22̃G[R[h
 * 	 wLogSlot  --- G[foCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA22_ERR_WRAPDLL;
	}
	return (*pAisa22GetLastError)(wLogSlot);
}

static BOOL Aisa22wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa22GetVersion ̃AhX擾
	pAisa22GetVersion = GetProcAddress(hDLL, _T("Aisa22GetVersion"));
	if (pAisa22GetVersion == NULL) {
		return FALSE;
	}

	// Aisa22Create ̃AhX擾
	pAisa22Create = GetProcAddress(hDLL, _T("Aisa22Create"));
	if (pAisa22Create == NULL) {
		return FALSE;
	}

	// Aisa22Close ̃AhX擾
	pAisa22Close = GetProcAddress(hDLL, _T("Aisa22Close"));
	if (pAisa22Close == NULL) {
		return FALSE;
	}

	// Aisa22GetResource ̃AhX擾
	pAisa22GetResource = GetProcAddress(hDLL, _T("Aisa22GetResource"));
	if (pAisa22GetResource == NULL) {
		return FALSE;
	}

	// Aisa22InPort ̃AhX擾
	pAisa22InPort = GetProcAddress(hDLL, _T("Aisa22InPort"));
	if (pAisa22InPort == NULL) {
		return FALSE;
	}

	// Aisa22GetLastError ̃AhX擾
	pAisa22GetLastError = GetProcAddress(hDLL, _T("Aisa22GetLastError"));
	if (pAisa22GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
